package com.jigoku;

import com.badlogic.gdx.ApplicationListener;
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.InputProcessor;
import com.jigoku.backend.Director;
import com.jigoku.debug.DebugLevel;

public class ApplicationMain implements ApplicationListener, InputProcessor {
	private static Director director = new Director();
	@Override
	public void create() {
		// TODO Auto-generated method stub
		director.setStage(new DebugLevel(director));
		Thread.currentThread().setPriority(Thread.MAX_PRIORITY);
		Gdx.input.setInputProcessor(this);
	}

	@Override
	public void dispose() {
		// TODO Dispose of used content
	}

	@Override
	public void pause() {
		director.pause();
	}

	@Override
	public void render() {
		director.update(Gdx.graphics.getDeltaTime());
		director.draw();
	}

	@Override
	public void resize(int arg0, int arg1) {
		// TODO Resize window
		
	}

	@Override
	public void resume() {
		director.resume();
	}

	@Override public boolean touchDown (int x, int y, int pointer, int button) {
		return director.touchDown(x, y, pointer, button);
	}

	@Override public boolean touchUp (int x, int y, int pointer, int button) {
		return director.touchUp(x, y, pointer, button);
	}

	@Override public boolean touchDragged (int x, int y, int pointer) {
		return director.touchDragged(x, y, pointer);
	}

	@Override public boolean keyDown (int keycode) {
		return director.keyDown(keycode);
	}

	@Override public boolean keyUp (int keycode) {
		return director.keyUp(keycode);
	}

	@Override public boolean keyTyped (char character) {
		return director.keyTyped(character);
	}

	@Override public boolean touchMoved (int x, int y) {
		return director.touchMoved(x, y);
	}

	@Override public boolean scrolled (int amount) {
		return director.scrolled(amount);
	}
}
