package com.jigoku.backend;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.scenes.scene2d.Stage;

public class AbstractStage extends Stage {
	
	///////////////////////////////////////////////////////////////////////////////////////////////
	// INSTANCE VARIABLES
	///////////////////////////////////////////////////////////////////////////////////////////////
	public final String name;
	public final Director director;
	
	///////////////////////////////////////////////////////////////////////////////////////////////
	// CONSTRUCTORS
	///////////////////////////////////////////////////////////////////////////////////////////////
	public AbstractStage(String name, int width, int height, boolean stretch, Director d) {
		super(width, height, stretch);
		this.name = name;
		this.director = d;
	}
	
	public AbstractStage(String name, boolean stretch, Director d) {
		this(name, Gdx.graphics.getWidth(), Gdx.graphics.getHeight(), stretch, d);
	}
	
	public AbstractStage(String name, Director d) {
		this(name, true, d);
	}
}
