package com.jigoku.backend;

import java.util.List;

import com.badlogic.gdx.graphics.g2d.TextureAtlas;
import com.badlogic.gdx.graphics.g2d.TextureAtlas.AtlasRegion;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.math.Intersector;
import com.badlogic.gdx.math.MathUtils;
import com.badlogic.gdx.math.Rectangle;

public class Helper {
	public static float PI2 = MathUtils.PI * 2;
	
	///////////////////////////////////////////////////////////////////////////////////////////////
	// PUBLIC STATIC METHODS
	///////////////////////////////////////////////////////////////////////////////////////////////
	public static boolean RectangleContainsPoint(Rectangle r, float x, float y) {
		return (x >= r.x && x <= r.x + r.width && y >= r.y && y <= r.y + r.height);
	}
	
	public static TextureRegion[] convertAtlasRegionList(List<AtlasRegion> l) {
		TextureRegion[] retVal = new TextureRegion[l.size()];
		for(int i = 0; i < l.size(); i++)
			retVal[i] = (TextureRegion)l.get(i);
		return retVal;
	}
	
	public static AnimationExtended animationFromAtlas(TextureAtlas atlas, String animationName, float time) {
		return new AnimationExtended(time, convertAtlasRegionList(atlas.findRegions(animationName)));
	}
	
	public static float ReverseAngle(float rads) {
		return NormalizeAngle(rads + MathUtils.PI);
	}
	
	public static float NormalizeAngle(float rads) {
		while(rads >= PI2) rads -= PI2;
		while(rads < 0.0f) rads += PI2;
		return rads;
	}
	
	public static boolean collisionTest(AbstractObject first, AbstractObject second) {
		return Intersector.overlapRectangles(first.worldBoundingBox(), second.worldBoundingBox());
	}
}
