package com.jigoku.debug;

import com.badlogic.gdx.Gdx;
import com.jigoku.backend.Director;
import com.jigoku.backend.TileMap;
import com.jigoku.projectiles.BulletHandler;
import com.jigoku.stages.LevelStage;

public class DebugLevel extends LevelStage {
	TileMap map;
	BulletTestEnemy btest;
	DebugLayer dbLayer;

	public DebugLevel(Director d) {
		super("Debug Level", d);
		BulletHandler.load();
		
		//Tilemap
		map = new TileMap("data/tilemaps/", "DebugMap", 16, 16);
		map.setScroll(0.0f, 60.0f);
		
		//Bullet Tester
		btest = new BulletTestEnemy(Gdx.graphics.getWidth() / 2, Gdx.graphics.getHeight() / 2, d);
		enemies.addObject(btest);
		
		//Debug Layer
		dbLayer = new DebugLayer();
	}

	@Override 
	public void act(float dt) {
		super.act(dt);
		map.act(dt);
		dbLayer.getDataFromObjects(enemies);
		dbLayer.getDataFromObject(player);
	}

	@Override 
	public void draw() {
		map.draw();
		super.draw();
		batch.begin();
		dbLayer.draw(batch);
		batch.end();
		dbLayer.clear();
	}
	
	@Override
	public boolean keyDown(int keycode) {
		super.keyDown(keycode);
		btest.keyDown(keycode);
		return true;
	}
}
