package com.jigoku.objects;

import java.util.Vector;

import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import com.jigoku.projectiles.BulletHandler;

public class ObjectHandler {
	
	///////////////////////////////////////////////////////////////////////////////////////////////
	// INSTANCE VARIABLES
	///////////////////////////////////////////////////////////////////////////////////////////////
	public final Vector<Object> objects;
	protected final Vector<Object> scheduledAdd, scheduledRemove;
	
	///////////////////////////////////////////////////////////////////////////////////////////////
	// CONSTRUCTORS
	///////////////////////////////////////////////////////////////////////////////////////////////
	public ObjectHandler() {
		objects = new Vector<Object>();
		scheduledAdd = new Vector<Object>();
		scheduledRemove = new Vector<Object>();
	}
	
	///////////////////////////////////////////////////////////////////////////////////////////////
	// PUBLIC METHODS
	///////////////////////////////////////////////////////////////////////////////////////////////
	public Object addObject(Object o) {
		if(o == null)
			return o;
		o.handler = this;
		scheduledAdd.add(o);
		return o;
	}
	
	public void removeObject(Object o) {
		if(o == null)
			return;
		scheduledRemove.add(o);
	}
	
	public void act(float dt) {
		for(Object o : scheduledAdd) {
			objects.add(o);
			o.create();
		}
		for(Object o : scheduledRemove) {
			o.handler = null;
			objects.remove(o);
		}
		scheduledAdd.clear();
		scheduledRemove.clear();
		for(Object o : objects)
			o.act(dt);
	}
	
	public void draw(SpriteBatch batch) {
		for(Object o : objects)
			o.draw(batch);
	}
	
	public void checkCollisionWithObjects(ObjectHandler handler) {
		for(Object o : objects)
			o.checkCollisionWithObjects(handler);
	}
	
	public void checkCollisionWithProjectiles(BulletHandler handler) {
		for(Object o : objects)
			o.checkCollisionWithProjectiles(handler);
	}
}
