package com.jigoku.projectiles;

public class IntervalSplitter extends Splitter {
	
	///////////////////////////////////////////////////////////////////////////////////////////////
	// INSTANCE VARIABLES
	///////////////////////////////////////////////////////////////////////////////////////////////
	public final int totalSplits;
	public final float timeUntilSplits, timeBetweenSplits;
	private int timesSplit;
	private float stateTime;
	
	///////////////////////////////////////////////////////////////////////////////////////////////
	// CONSTRUCTORS
	///////////////////////////////////////////////////////////////////////////////////////////////
	public IntervalSplitter(IntervalSplitter s) {
		super(s);
		this.timeUntilSplits = s.timeUntilSplits;
		this.timeBetweenSplits = s.timeBetweenSplits;
		this.totalSplits = s.totalSplits;
		this.timesSplit = s.timesSplit;
		this.stateTime = s.stateTime;
	}
	
	public IntervalSplitter(Projectile[] splitList,
			float timeUntilSplits, float timeBetweenSplits, int totalSplits) {
		super(splitList);
		this.timeUntilSplits = timeUntilSplits;
		this.timeBetweenSplits = timeBetweenSplits;
		this.totalSplits = totalSplits;
		this.timesSplit = 0;
		this.stateTime = 0.0f;
	}
	
	public boolean act(float dt) {
		stateTime += dt;
		if(totalSplits < 0 || (stateTime >= timeUntilSplits && timesSplit < totalSplits )) {
			float nextSplitTime = timeUntilSplits + (timeBetweenSplits * timesSplit);
			if(stateTime >= nextSplitTime) {
				timesSplit++;
				return true;
			}
		}
		return false;
	}

	@Override
	public IntervalSplitter clone() {
		return new IntervalSplitter(this);
	}
}
