package com.jigoku.stages;

import com.badlogic.gdx.Gdx;
import com.jigoku.backend.AbstractStage;
import com.jigoku.backend.Director;
import com.jigoku.objects.ObjectHandler;
import com.jigoku.objects.PlayerShip;
import com.jigoku.projectiles.BulletHandler;

public class LevelStage extends AbstractStage {
	public BulletHandler playerBullets, enemyBullets;
	public ObjectHandler enemies;
	public PlayerShip player;
	protected float totalPlaytime;

	public LevelStage(String name, Director d) {
		super(name, d);
		playerBullets = new BulletHandler(100);
		enemyBullets = new BulletHandler(10000);
		enemies = new ObjectHandler();
		player = new PlayerShip(Gdx.graphics.getWidth() / 2, 50.0f, playerBullets, d);
		this.totalPlaytime = 0.0f;
	}

	@Override 
	public void act(float dt) {
		//Update Logic
		super.act(dt);
		player.act(dt);
		playerBullets.act(dt);
		enemyBullets.act(dt);
		enemies.act(dt);
		totalPlaytime += dt;
		
		//TODO: Check Collisions
		enemies.checkCollisionWithProjectiles(playerBullets);
		player.checkCollisionWithProjectiles(enemyBullets);
	}

	@Override 
	public void draw() {
		camera.update();
		batch.setProjectionMatrix(camera.combined);	
		batch.begin();
		enemies.draw(batch);
		playerBullets.draw(batch);
		enemyBullets.draw(batch);
		player.draw(batch);
		batch.end();
	}
	
	@Override 
	public boolean keyDown (int keycode) {
		player.keyDown(keycode);
		return true;
	}
	
	@Override
	public boolean keyTyped(char key) {
		return false;
	}
	
	@Override 
	public boolean keyUp (int keycode) {
		player.keyUp(keycode);
		return true;
	}
}
